import cheerio from "cheerio";
import { isTypeReferenceNode } from "typescript";

export namespace Template {
    export async function check(html: string) {
        try {
            const $ = cheerio.load(html);

            return false;
        } catch (error) {
            console.error(`Error occured during stock check!`);
            return false;
        }
    }
}

export namespace LDJsonParser {
    export async function check(html: string) {
        try {
            const $ = cheerio.load(html);
            let stock = false;

            $('script[type="application/ld+json"]').each((index, element) => {
                let json = JSON.parse($(element).html());
            
                if (json["@type"]) {
                    if (json["@type"].includes("Product")) {
                        if (Array.isArray(json["offers"])) {
                            let anyStock = false;
                            
                            for (let index in json["offers"]) {
                                if (json["offers"][index]["availability"].includes("InStock")) {
                                    anyStock = true;
                                }
                            }

                            if (anyStock) {
                                stock = true;
                                return;
                            }
                        } else {
                            if (json["offers"]["availability"].includes("InStock")) {
                                stock = true;
                                return;
                            }
                        }
                    }
                }
            });

            return stock;
        } catch (error) {
            console.log(error);
            console.error(`Error occured during stock check!`);
            return false;
        }
    }
}


export namespace Dobey {
    export async function check(html: string) {
        try {
            const $ = cheerio.load(html);
            if ($("#product_view #stock_indicator").hasClass("stock_green")) {
                return true;
            } else {
                return false;
            }
        } catch (error) {
            console.log(error);
            console.error(`Error occured during stock check!`);
            return false;
        }
    }
}

